# ONLYOFFICE Document Server roadmap

This document provides the roadmap of the planned ONLYOFFICE Document Server changes.

This is an updated and corrected version of the roadmap.
We also reserve the right to change it when necessary.

## Version 6.0

### All editors

* 3D in autoshapes and pictures
* Mobile versions improvements
* Equation editor autocorrect
* Border styles (double)
* Paste Options (Keep Source Formatting, Merge Formatting, Keep Text Only etc.)
* Document templates
* Undo/redo for fast collaborative editing
* Protecting parts of documents from being edited/copied
* Multiple clipboard
* Plugins development

### Document editor

* New content controls for filling forms
* Table of contents for tables and images
* Endnotes
* The exact height of the rows in the table
* Support of % in brush
* Backgrounds
* Different underlining (double line, wavy line, etc)
* Frames for pictures and templates
* Shadow for pictures
* Inextricable paragraph (wrap)
* Drawing Canvas support

### Spreadsheet editor

* Speedup
* Effects
* Backgrounds
* Adjustable cell format (numerical, monetary, etc)
* Improvement of auto-filters (there are no settings of
  style parameters for spreadsheets, spreadsheet resize using mouse,
  the auto-adding of lines within the formatted spreadsheets)
* Version History
* Review
* Formulas improvements (new formulas  + speedup + wizard)
* Pivot tables
* Pivot charts
* Data (Drop-down lists)
* Sheet and data protection
* Conditional formatting (correct display for
  data bars formatting, support for gradient for data bars)
* Slicers (without pivot support)
* Autofilling algorithm  modification (adding various options,
  for example, copy formatting only)
* Forms

### Presentation editor

* Auto-fit text size in AutoShape
* Themes and theme editor
* Vertical text
* Animations
* SmartArt support

### Interface

* Adding the information about updates in a new version
* Toolbar adaptation for various screen resolutions
* Customization

### Desktop and mobile editors

* Development of interface for document editor for Windows, Mac, Ubuntu
* Development of SDK presentation editor for Windows, Mac OS, iOS platforms
* Development of SDK spreadsheet editor for Windows, Mac OS, iOS platforms
* Development of interface for presentation editor for iPad
* Development of SDK document and spreadsheet editors for Android
* Development of interface for document editor for Android
* Development of SDK presentation editor for Android
* Development of interface for presentation editors for Android
* Development of co-editing for document editor for iPad
* Development of co-editing for spreadsheet editor for iPad
* Print preview in the desktop editors

### Backend

* Scalability and clustering for commercial builds
